/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CarsFrame.java
 *
 * Created on 5.5.2011, 18:13:43
 */
package cargui;

import java.awt.Color;
import java.util.Locale;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author xkremser
 */
public class CarsFrame extends javax.swing.JFrame {

    private Random random = new Random();
    private static final String[] CAR_TYPES = {"Škoda Felicia", "Škoda Octavia",
        "Ford Focus", "Ford Fiesta", "Renault Clio", "Porsche Carrera"};
    private static final Color[] CAR_COLORS = {Color.BLACK, Color.BLUE,
        Color.RED, Color.GREEN, Color.PINK, Color.WHITE, Color.YELLOW};

    public CarsFrame() {
        try {
            UIManager.LookAndFeelInfo[] infos = UIManager.getInstalledLookAndFeels();
            System.out.println("Available look and feels:");
            for (LookAndFeelInfo info : infos) {
                System.out.println("L&F " + info.getClassName());
            }
//            UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(CarsFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            Logger.getLogger(CarsFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(CarsFrame.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedLookAndFeelException ex) {
            Logger.getLogger(CarsFrame.class.getName()).log(Level.SEVERE, null, ex);
        }
        Locale.setDefault(new Locale("cs"));
        initComponents();
        CarsTableModel model = (CarsTableModel) jTableCars.getModel();
        model.addCar(new Car(1, "Renault Clio", "2B6 7895", Color.RED, Fuel.GAS));
        model.addCar(new Car(2, "Škoda 120", "2A1 9999", Color.PINK, Fuel.LPG));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jOwnChooser = new javax.swing.JColorChooser();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableCars = new javax.swing.JTable();
        jButtonAddCar = new javax.swing.JButton();

        jButton1.setText("jButton1");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTableCars.setModel(new CarsTableModel());
        ColorCellRenderer renderer = new ColorCellRenderer();
        jTableCars.getTableHeader().setDefaultRenderer(new HeaderRenderer());
        jTableCars.setDefaultRenderer(Color.class, renderer);

        jTableCars.setDefaultEditor(Color.class, new ColorPickerEditor());

        JComboBox fuelComboBox = new JComboBox();
        for (Fuel f : Fuel.values()) {
            fuelComboBox.addItem(f);
        }
        jTableCars.getColumnModel().getColumn(CarsTableModel.COLUMNS.FUEL.ordinal()).setCellEditor(new DefaultCellEditor(fuelComboBox));
        jTableCars.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTableCarsMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTableCars);

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("cargui/i18n"); // NOI18N
        jButtonAddCar.setText(bundle.getString("randomButton")); // NOI18N
        jButtonAddCar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddCarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 401, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(266, Short.MAX_VALUE)
                .addComponent(jButtonAddCar)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonAddCar)
                .addGap(12, 12, 12))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonAddCarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddCarActionPerformed
        CarsTableModel model = (CarsTableModel) jTableCars.getModel();
        model.addCar(randomCar());
    }//GEN-LAST:event_jButtonAddCarActionPerformed

    private void jTableCarsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableCarsMouseClicked
    }//GEN-LAST:event_jTableCarsMouseClicked

    private Car randomCar() {
        return new Car(
                random.nextInt(10000),
                CAR_TYPES[random.nextInt(CAR_TYPES.length)],
                "2C1 " + (random.nextInt(9000) + 1000),
                CAR_COLORS[random.nextInt(CAR_COLORS.length)],
                Fuel.values()[random.nextInt(Fuel.values().length)]);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new CarsFrame().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButtonAddCar;
    private javax.swing.JColorChooser jOwnChooser;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableCars;
    // End of variables declaration//GEN-END:variables
}
