/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cargui;

import java.awt.Color;

import java.util.ArrayList;

import java.util.List;

import javax.swing.table.AbstractTableModel;

public class CarsTableModel extends AbstractTableModel {

    public static enum COLUMNS {

        ID, REGISTRATION, TYPE, COLOR, FUEL
    }
    private List<Car> cars = new ArrayList<Car>();

    @Override
    public int getRowCount() {
        return cars.size();
    }

    @Override
    public int getColumnCount() {
        return COLUMNS.values().length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Car car = cars.get(rowIndex);
        switch (COLUMNS.values()[columnIndex]) {
            case ID:
                return car.getId();
            case REGISTRATION:
                return car.getRegistrationNumber();
            case TYPE:
                return car.getType();
            case COLOR:
                return car.getColor();
            case FUEL:
                return car.getFuel();
            default:
                throw new IllegalArgumentException("columnIndex");
        }
    }

    public void addCar(Car car) {
        cars.add(car);
        int lastRow = cars.size() - 1;
        fireTableRowsInserted(lastRow, lastRow);
    }

    @Override
    public String getColumnName(int columnIndex) {
        switch (COLUMNS.values()[columnIndex]) {
            case ID:
                return "id";
            case REGISTRATION:
                return "registration";
            case TYPE:
                return "type";
            case COLOR:
                return "color";
            case FUEL:
                return "fuel";
            default:
                throw new IllegalArgumentException("columnIndex");
        }
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        switch (COLUMNS.values()[columnIndex]) {
            case ID:
                return Integer.class;
            case REGISTRATION:
            case TYPE:
                return String.class;
            case COLOR:
                return Color.class;
            case FUEL:
                return Fuel.class;
            default:
                throw new IllegalArgumentException("columnIndex");
        }

    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        Car car = cars.get(rowIndex);
        switch (COLUMNS.values()[columnIndex]) {
            case ID:
                car.setId((Integer) aValue);
                break;
            case REGISTRATION:
                car.setRegistrationNumber((String) aValue);
                break;
            case TYPE:
                car.setType((String) aValue);
                break;
            case COLOR:
                car.setColor((Color) aValue);
                break;
            case FUEL:
                car.setFuel((Fuel) aValue);
                break;
            default:
                throw new IllegalArgumentException("columnIndex");
        }
        fireTableCellUpdated(rowIndex, columnIndex);
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        switch (COLUMNS.values()[columnIndex]) {
            case REGISTRATION:
            case TYPE:
            case FUEL:
            case COLOR:
                return true;
            case ID:
                return false;
            default:
                throw new IllegalArgumentException("columnIndex");
        }
    }
}
