/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cargui;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ResourceBundle;
import javax.swing.AbstractCellEditor;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;

/**
 *
 * @author freon
 */
public class ColorPickerEditor extends AbstractCellEditor implements TableCellEditor {

    private Color currentColor;
    private JButton button;
    private JColorChooser colorChooser;
    private JDialog dialog;
    private static final String EDIT = "edit";

    public ColorPickerEditor() {
        button = new JButton();
        button.setActionCommand(EDIT);
        ActionListener listener = new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                if (EDIT.equals(e.getActionCommand())) {
                    button.setBackground(currentColor);
                    colorChooser.setColor(currentColor);
                    dialog.setVisible(true);

                    fireEditingStopped();

                } else {
                    currentColor = colorChooser.getColor();
                }
            }
        };
        button.addActionListener(listener);
        button.setBorderPainted(false);

        colorChooser = new JColorChooser();
        dialog = JColorChooser.createDialog(button, ResourceBundle.getBundle("cargui.i18n").getString("chooseColor"), true, colorChooser, listener, null);
    }

    @Override
    public Object getCellEditorValue() {
        return currentColor;
    }

    @Override
    public Component getTableCellEditorComponent(JTable table, Object value,
            boolean isSelected,
            int row, int column) {
        currentColor = (Color) value;
        return button;
    }
}
